// Generated by CoffeeScript 1.3.3
(function() {
  var EventEmitter, SourceFile, SourceFileList, helpers, logger, sysPath,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  EventEmitter = require('events').EventEmitter;

  sysPath = require('path');

  SourceFile = require('./source_file');

  helpers = require('../helpers');

  logger = require('../logger');

  module.exports = SourceFileList = (function(_super) {

    __extends(SourceFileList, _super);

    SourceFileList.prototype.RESET_TIME = 100;

    function SourceFileList(config) {
      this.config = config;
      this._unlink = __bind(this._unlink, this);

      this._change = __bind(this._change, this);

      this._compile = __bind(this._compile, this);

      this._resetTimer = __bind(this._resetTimer, this);

      this.files = [];
      this.on('change', this._change);
      this.on('unlink', this._unlink);
    }

    SourceFileList.prototype._ignored = function(path) {
      var paths;
      paths = this.config.paths;
      return helpers.startsWith(path, paths.assets) || helpers.startsWith(sysPath.basename(path), '_') || (path === paths.config || path === paths.packageConfig);
    };

    SourceFileList.prototype._resetTimer = function() {
      var _this = this;
      if (this.timer != null) {
        clearTimeout(this.timer);
      }
      return this.timer = setTimeout((function() {
        return _this.emit('ready');
      }), this.RESET_TIME);
    };

    SourceFileList.prototype._getByPath = function(path) {
      return this.files.filter(function(file) {
        return file.path === path;
      })[0];
    };

    SourceFileList.prototype._compileDependentFiles = function(path) {
      var _this = this;
      this.files.filter(function(dependent) {
        return dependent.dependencies.length;
      }).filter(function(dependent) {
        return __indexOf.call(dependent.dependencies, path) >= 0;
      }).forEach(this._compile);
      return this._resetTimer();
    };

    SourceFileList.prototype._compile = function(file) {
      var _this = this;
      return file.compile(function(error) {
        logger.debug("Compiled file '" + file.path + "'");
        if (error != null) {
          return logger.error("" + file.compilerName + " failed in '" + file.path + "' -- " + error);
        }
        _this._compileDependentFiles(file.path);
        return _this._resetTimer();
      });
    };

    SourceFileList.prototype._add = function(path, compiler, isHelper) {
      var file, isVendor;
      isVendor = helpers.startsWith(path, this.config.paths.vendor);
      file = new SourceFile(path, compiler, isHelper, isVendor);
      this.files.push(file);
      return file;
    };

    SourceFileList.prototype._change = function(path, compiler, isHelper) {
      var file;
      if ((this._ignored(path)) || !compiler) {
        return this._compileDependentFiles(path);
      }
      file = this._getByPath(path);
      this._compile(file != null ? file : this._add(path, compiler, isHelper));
      return this._resetTimer();
    };

    SourceFileList.prototype._unlink = function(path) {
      var file;
      if (this._ignored(path)) {
        return this._compileDependentFiles(path);
      }
      file = this._getByPath(path);
      this.files.splice(this.files.indexOf(file), 1);
      return this._resetTimer();
    };

    return SourceFileList;

  })(EventEmitter);

}).call(this);
