// Generated by CoffeeScript 1.3.3
(function() {
  var EventEmitter, FSWatcher, common, fs, sysPath, watch,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __slice = [].slice;

  EventEmitter = require('events').EventEmitter;

  fs = require('fs');

  sysPath = require('path');

  common = require('./common');

  FSWatcher = (function(_super) {

    __extends(FSWatcher, _super);

    function FSWatcher(files, options) {
      var _base, _ref;
      this.options = options;
      this._handle = __bind(this._handle, this);

      this.watched = {};
      this.watchers = [];
      if ((_ref = (_base = this.options).persistent) == null) {
        _base.persistent = false;
      }
      this._ignored = (function() {
        switch (toString.call(options.ignored)) {
          case '[object RegExp]':
            return function(string) {
              return options.ignored.test(string);
            };
          case '[object Function]':
            return options.ignored;
          default:
            return function() {
              return false;
            };
        }
      })();
      this.add(files);
    }

    FSWatcher.prototype._getWatchedDir = function(directory) {
      var _base, _ref;
      return (_ref = (_base = this.watched)[directory]) != null ? _ref : _base[directory] = [];
    };

    FSWatcher.prototype._watch = function(item, callback) {
      var basename, options, parent,
        _this = this;
      parent = this._getWatchedDir(sysPath.dirname(item));
      basename = sysPath.basename(item);
      if (__indexOf.call(parent, basename) >= 0) {
        return;
      }
      parent.push(basename);
      if (process.platform === 'win32') {
        return this.watchers.push(fs.watch(item, {
          persistent: this.options.persistent
        }, function() {
          return typeof callback === "function" ? callback(item) : void 0;
        }));
      } else {
        options = {
          persistent: this.options.persistent,
          interval: 100
        };
        return fs.watchFile(item, options, function(curr, prev) {
          if (curr.mtime.getTime() !== prev.mtime.getTime()) {
            return callback(item);
          }
        });
      }
    };

    FSWatcher.prototype._handleFile = function(file) {
      var _this = this;
      this._watch(file, function(file) {
        return _this.emit('change', file);
      });
      return this.emit('add', file);
    };

    FSWatcher.prototype._handleDir = function(directory) {
      var read,
        _this = this;
      read = function(directory) {
        return fs.readdir(directory, function(error, current) {
          var previous;
          if (error != null) {
            return _this.emit('error', error);
          }
          if (!current) {
            return;
          }
          previous = _this._getWatchedDir(directory);
          previous.filter(function(file) {
            return __indexOf.call(current, file) < 0;
          }).forEach(function(file) {
            var path;
            path = sysPath.join(directory, file);
            previous.splice(previous.indexOf(file), 1);
            return _this.emit('unlink', path);
          });
          return current.filter(function(file) {
            return __indexOf.call(previous, file) < 0;
          }).forEach(function(file) {
            return _this._handle(sysPath.join(directory, file));
          });
        });
      };
      read(directory);
      return this._watch(directory, read);
    };

    FSWatcher.prototype._handle = function(item) {
      var _this = this;
      if (this._ignored(item)) {
        return;
      }
      return fs.realpath(item, function(error, path) {
        if (error != null) {
          return _this.emit('error', error);
        }
        return fs.stat(item, function(error, stats) {
          if (error != null) {
            return _this.emit('error', error);
          }
          if (stats.isFile()) {
            _this._handleFile(item);
          }
          if (stats.isDirectory()) {
            return _this._handleDir(item);
          }
        });
      });
    };

    FSWatcher.prototype.add = function(files) {
      if (!Array.isArray(files)) {
        files = [files];
      }
      files.forEach(this._handle);
      return this;
    };

    FSWatcher.prototype.emit = function() {
      var args, event;
      event = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      FSWatcher.__super__.emit.apply(this, ['all', event].concat(__slice.call(args)));
      FSWatcher.__super__.emit.apply(this, arguments);
      return this;
    };

    FSWatcher.prototype.on = function() {
      FSWatcher.__super__.on.apply(this, arguments);
      return this;
    };

    FSWatcher.prototype.close = function() {
      var _this = this;
      this.watchers.forEach(function(watcher) {
        return watcher.close();
      });
      Object.keys(this.watched).forEach(function(directory) {
        return _this.watched[directory].forEach(function(file) {
          return fs.unwatchFile(sysPath.join(directory, file));
        });
      });
      this.watched = {};
      return this;
    };

    return FSWatcher;

  })(EventEmitter);

  module.exports = watch = function(files, options) {
    var callback;
    if (typeof callback === "undefined" || callback === null) {
      callback = options;
      options = {
        ignored: common.ignored,
        include: true,
        recurse: true,
        persistent: true
      };
    }
    return new FSWatcher(files, options);
  };

}).call(this);
